//
// FUNKVIEW.CPP - The member function definition for TMyApp.
//
//  Copyright (C) Borland International, 1991.
//

#define Uses_TView
#define Uses_TWindow
#define Uses_TPalette
#define Uses_TDrawBuffer
#define Uses_TStreamable
#define Uses_TStreamableClass
#include <tv.h>
__link( RView );
__link( RWindow );

#include <stdlib.h>         // For random number generator

#include "funkview.h"       // Class definition


//
//  FunkyView constructor
//
#define cpFunkyPalette  "\x6"

char localPalette[] = "\x8\x9\xA\xB\xC\xD\xE\xF";

FunkyView::FunkyView( TRect& r, char *word ) :
    TView( r )
{
    text = newStr( word );
}

void FunkyView::draw()
{
    TDrawBuffer buf;
    char textAttr = getColor(1) & 0xF0 + localPalette[random(8)];

    buf.moveChar(0, ' ', textAttr, size.x);
    buf.moveStr(0, text, textAttr);
    writeLine(0, 0, size.x, 1, buf);
}

TPalette& FunkyView::getPalette() const
{
    static TPalette palette( cpFunkyPalette, sizeof(cpFunkyPalette)-1 );
    return palette;
}

// Stream support //

const char * const FunkyView::name = "FunkyView";

void FunkyView::write( opstream& os )
{
    TView::write( os );
    os.writeString(text);
}

void *FunkyView::read( ipstream& is )
{
    text = new char [32];
    TView::read( is );
    is.readString(text, 32);

    return this;
}

TStreamable *FunkyView::build()
{
    return new FunkyView( streamableInit );
}

TStreamableClass RFunkyView( FunkyView::name,
                             FunkyView::build,
                             __DELTA( FunkyView )
                           );

//
// FunkyWindow
//

FunkyWindow::FunkyWindow( TRect& bounds, char *words ) :
    TWindow( bounds, 0, wnNoNumber ),
    TWindowInit( FunkyWindow::initFrame )
{
    bounds = getExtent();
    bounds.grow(-2, -2);
    insert( new FunkyView(bounds, words) );

    flags = wfMove | wfClose;
}


//
// Use inherited read/write functions since there are no data members
// in this object.
//

const char * const FunkyWindow::name = "FunkyWindow";

TStreamable *FunkyWindow::build()
{
    return new FunkyWindow( streamableInit );
}

TStreamableClass RFunkyWindow( FunkyWindow::name,
                               FunkyWindow::build,
                               __DELTA( FunkyWindow )
                             );

