//
// FUNKVIEW.H - The class definition for TMyApp.
//
//  Copyright (C) Borland International, 1991.
//

//
// class FunkyView
//      View that simply displays some text on the screen in a random color.
//
// Member functions:
//      FunkyView - Constructor
//      ~FunkyView - Destructor
//      draw - Display the text
//      getPalette - To have a color to display the text in.
//

class FunkyView : public TView
{

public:

    FunkyView( TRect& r, char *word );
    virtual ~FunkyView() { delete text; }
    virtual void draw();
    virtual TPalette& getPalette() const;

private:

    char *text;

// Stream support is from here on down. //

};


//
// FunkyWindow - provides encapsulation for FunkyView, as well as the
//   ability to move the view around the screen and remove it from the
//   desktop with little coding (since TWindow's automatically call cmClose)
//
// Member functions:
//      FunkyWindow - Constructor
//      sizeLimits - so we can have a smaller than regulation TWindow.
//

#define FUNK_WIDTH  33
#define FUNK_HEIGHT  5

#pragma argsused

class FunkyWindow : public TWindow
{

public:

    FunkyWindow( TRect& r, char *words);
    virtual ~FunkyWindow() {}
    virtual void sizeLimits( TPoint& min, TPoint& )
        { min.x = FUNK_WIDTH; min.y = FUNK_HEIGHT; }

// Stream support is from here on down. //

};
