//
// MYAPP.CPP - The member function definition for TMyApp.
//
//  Copyright (C) Borland International, 1991.
//

#define Uses_TApplication
#define Uses_TRect
#define Uses_TKeys
#define Uses_TMenuBar
#define Uses_TMenuItem
#define Uses_TSubMenu
#define Uses_TStatusLine
#define Uses_TStatusDef
#define Uses_TStatusItem
#define Uses_TEvent
#define Uses_TDialog
#define Uses_TStaticText
#define Uses_TButton
#define Uses_TDeskTop
#define Uses_TWindow
#define Uses_MsgBox
#include <tv.h>

#include <strstrea.h>       // String stream library
#include <stdlib.h>         // Standard library
#include <stdio.h>          // For remove()
#include <dir.h>            // For findfirst()

#include "cmds.h"
#include "myapp.h"          // Class definitions
#include "funkview.h"       // Class definitions


//
// TMyApp - Constructor.
//

TMyApp::TMyApp() :
    TProgInit( &TMyApp::initStatusLine,
               &TMyApp::initMenuBar,
               &TMyApp::initDeskTop )
{
}


//
// initMenuBar - Initialize the menu bar. It will be called by the virtual base
//               TProgInit constructor.
//

TMenuBar *TMyApp::initMenuBar( TRect bounds )
{
    bounds.b.y = bounds.a.y + 1;

    TMenuBar *mainMenu = new TMenuBar (bounds,
        *new TSubMenu ("~~", kbAltSpace ) +        //  is \xF0
            *new TMenuItem ("~A~bout...", cmAboutCmd, kbAltA, hcNoContext, "Alt-A") +
             newLine() +
            *new TMenuItem ("~E~xit", cmQuit, kbAltE, hcNoContext, "Alt-E") +

        *new TSubMenu("~W~indow", kbAltW ) +
            *new TMenuItem("~F~unky View", cmFunkCmd, kbNoKey) +
            *new TMenuItem("~C~lose", cmClose, kbAltF3, hcNoContext, "Alt-F3")

        );

    return( mainMenu );
}


//
// initStatusLine - Initialize the status line. It will be called by the
//                  virtual base TProgInit constructor.
//

TStatusLine *TMyApp::initStatusLine( TRect bounds )
{
    bounds.a.y = bounds.b.y - 1;

    TStatusLine *statusLine = new TStatusLine (bounds,
        *new TStatusDef(0, 0xFFFF) +
            *new TStatusItem("~Alt-X~ Exit", kbAltX, cmQuit) +
            *new TStatusItem("~Alt-A~ About", kbAltA, cmAboutCmd) +
            *new TStatusItem("~Alt-F~ Funky", kbAltF, cmFunkCmd) +
            *new TStatusItem("~Alt-F3~ Close", kbAltF3, cmClose)
        );

    return (statusLine);
}


//
// handleEvent - Need to handle the event for the menu and status line choice
//               cmAboutCmd.
//

void TMyApp::handleEvent(TEvent& event)
{
    TApplication::handleEvent(event);

    switch(event.what)
    {
        case evCommand:             // handle COMMAND events
        {
            switch(event.message.command)
            {
                case cmAboutCmd:
                    aboutDlg();     // Bring up the dialog box
                    break;

                case cmFunkCmd:
                    funkView();     // Bring up funky view
                    break;

                default:
                    return;
            }
            clearEvent(event);      // Clear the event we handled
        }
    }
}


//
// aboutDlg - Creates a about dialog box and execute the dialog box.
//

void TMyApp::aboutDlg()
{
    TDialog *aboutDlgBox = new TDialog(TRect(0, 0, 47, 9), "About");
    char temp[200];

//
// Use the strstream library to put the ABOUT text into a string.  We
// don't need << operators on the intermediate lines because the compiler
// will concatenate the strings automatically.  The ^C character begining
// each line will force that line to be centered.  The ' ' character between
// each pair of newlines is to avoid a quirk that two adjacent newlines are
// treated as one.
//

    ostrstream(temp,200) << "\003STREAM.CPP\n \n"
                            "\003Copyright (c) 1991\n \n"
                            "\003Copyright (C) Borland International, 1991."
                            "\n \n"
                         << ends;

    aboutDlgBox->insert( new TStaticText(TRect(2,2,45,8), temp) );
    aboutDlgBox->insert( new TButton(TRect(18,10,29,12), "OK", cmOK, bfDefault) );

    aboutDlgBox->options |= ofCentered;     // Centered on the screen

    deskTop->execView( aboutDlgBox );       // Bring up the box as modal

    destroy( aboutDlgBox );                 // Destroy the box
}


static char *sayings[] = { "             42              ",
                           "  what do you get when you   ",
                           "    multiply 7 by 9?         ",
                           "  What is the answer to the  ",
                           "    to the great question?   "
                         };
const int numSayings = sizeof(sayings) / sizeof(char *);

void TMyApp::funkView()
{
    unsigned short x, y;

    x = random(79-FUNK_WIDTH);
    y = random(23-FUNK_HEIGHT);

    FunkyWindow *v = new FunkyWindow( TRect(x, y, x+FUNK_WIDTH, y+FUNK_HEIGHT),
                                      sayings[random(numSayings)]
                                    );
    deskTop->insert( v );
}
